// Code generated by bpf2go; DO NOT EDIT.
//go:build 386 || amd64

package nodejs

import (
	"bytes"
	_ "embed"
	"fmt"
	"io"

	"github.com/cilium/ebpf"
)

// loadBpf_debug returns the embedded CollectionSpec for bpf_debug.
func loadBpf_debug() (*ebpf.CollectionSpec, error) {
	reader := bytes.NewReader(_Bpf_debugBytes)
	spec, err := ebpf.LoadCollectionSpecFromReader(reader)
	if err != nil {
		return nil, fmt.Errorf("can't load bpf_debug: %w", err)
	}

	return spec, err
}

// loadBpf_debugObjects loads bpf_debug and converts it into a struct.
//
// The following types are suitable as obj argument:
//
//	*bpf_debugObjects
//	*bpf_debugPrograms
//	*bpf_debugMaps
//
// See ebpf.CollectionSpec.LoadAndAssign documentation for details.
func loadBpf_debugObjects(obj interface{}, opts *ebpf.CollectionOptions) error {
	spec, err := loadBpf_debug()
	if err != nil {
		return err
	}

	return spec.LoadAndAssign(obj, opts)
}

// bpf_debugSpecs contains maps and programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type bpf_debugSpecs struct {
	bpf_debugProgramSpecs
	bpf_debugMapSpecs
}

// bpf_debugSpecs contains programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type bpf_debugProgramSpecs struct {
	AsyncReset    *ebpf.ProgramSpec `ebpf:"async_reset"`
	AsyncResetRet *ebpf.ProgramSpec `ebpf:"async_reset_ret"`
	EmitAsyncInit *ebpf.ProgramSpec `ebpf:"emit_async_init"`
}

// bpf_debugMapSpecs contains maps before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type bpf_debugMapSpecs struct {
	ActiveNodejsIds *ebpf.MapSpec `ebpf:"active_nodejs_ids"`
	AsyncResetArgs  *ebpf.MapSpec `ebpf:"async_reset_args"`
	DebugEvents     *ebpf.MapSpec `ebpf:"debug_events"`
	Events          *ebpf.MapSpec `ebpf:"events"`
	NodejsParentMap *ebpf.MapSpec `ebpf:"nodejs_parent_map"`
	PidCache        *ebpf.MapSpec `ebpf:"pid_cache"`
	ValidPids       *ebpf.MapSpec `ebpf:"valid_pids"`
}

// bpf_debugObjects contains all objects after they have been loaded into the kernel.
//
// It can be passed to loadBpf_debugObjects or ebpf.CollectionSpec.LoadAndAssign.
type bpf_debugObjects struct {
	bpf_debugPrograms
	bpf_debugMaps
}

func (o *bpf_debugObjects) Close() error {
	return _Bpf_debugClose(
		&o.bpf_debugPrograms,
		&o.bpf_debugMaps,
	)
}

// bpf_debugMaps contains all maps after they have been loaded into the kernel.
//
// It can be passed to loadBpf_debugObjects or ebpf.CollectionSpec.LoadAndAssign.
type bpf_debugMaps struct {
	ActiveNodejsIds *ebpf.Map `ebpf:"active_nodejs_ids"`
	AsyncResetArgs  *ebpf.Map `ebpf:"async_reset_args"`
	DebugEvents     *ebpf.Map `ebpf:"debug_events"`
	Events          *ebpf.Map `ebpf:"events"`
	NodejsParentMap *ebpf.Map `ebpf:"nodejs_parent_map"`
	PidCache        *ebpf.Map `ebpf:"pid_cache"`
	ValidPids       *ebpf.Map `ebpf:"valid_pids"`
}

func (m *bpf_debugMaps) Close() error {
	return _Bpf_debugClose(
		m.ActiveNodejsIds,
		m.AsyncResetArgs,
		m.DebugEvents,
		m.Events,
		m.NodejsParentMap,
		m.PidCache,
		m.ValidPids,
	)
}

// bpf_debugPrograms contains all programs after they have been loaded into the kernel.
//
// It can be passed to loadBpf_debugObjects or ebpf.CollectionSpec.LoadAndAssign.
type bpf_debugPrograms struct {
	AsyncReset    *ebpf.Program `ebpf:"async_reset"`
	AsyncResetRet *ebpf.Program `ebpf:"async_reset_ret"`
	EmitAsyncInit *ebpf.Program `ebpf:"emit_async_init"`
}

func (p *bpf_debugPrograms) Close() error {
	return _Bpf_debugClose(
		p.AsyncReset,
		p.AsyncResetRet,
		p.EmitAsyncInit,
	)
}

func _Bpf_debugClose(closers ...io.Closer) error {
	for _, closer := range closers {
		if err := closer.Close(); err != nil {
			return err
		}
	}
	return nil
}

// Do not access this directly.
//
//go:embed bpf_debug_x86_bpfel.o
var _Bpf_debugBytes []byte
