// Code generated by bpf2go; DO NOT EDIT.
//go:build 386 || amd64

package nodejs

import (
	"bytes"
	_ "embed"
	"fmt"
	"io"

	"github.com/cilium/ebpf"
)

// loadBpf returns the embedded CollectionSpec for bpf.
func loadBpf() (*ebpf.CollectionSpec, error) {
	reader := bytes.NewReader(_BpfBytes)
	spec, err := ebpf.LoadCollectionSpecFromReader(reader)
	if err != nil {
		return nil, fmt.Errorf("can't load bpf: %w", err)
	}

	return spec, err
}

// loadBpfObjects loads bpf and converts it into a struct.
//
// The following types are suitable as obj argument:
//
//	*bpfObjects
//	*bpfPrograms
//	*bpfMaps
//
// See ebpf.CollectionSpec.LoadAndAssign documentation for details.
func loadBpfObjects(obj interface{}, opts *ebpf.CollectionOptions) error {
	spec, err := loadBpf()
	if err != nil {
		return err
	}

	return spec.LoadAndAssign(obj, opts)
}

// bpfSpecs contains maps and programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type bpfSpecs struct {
	bpfProgramSpecs
	bpfMapSpecs
}

// bpfSpecs contains programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type bpfProgramSpecs struct {
	AsyncReset    *ebpf.ProgramSpec `ebpf:"async_reset"`
	AsyncResetRet *ebpf.ProgramSpec `ebpf:"async_reset_ret"`
	EmitAsyncInit *ebpf.ProgramSpec `ebpf:"emit_async_init"`
}

// bpfMapSpecs contains maps before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type bpfMapSpecs struct {
	ActiveNodejsIds *ebpf.MapSpec `ebpf:"active_nodejs_ids"`
	AsyncResetArgs  *ebpf.MapSpec `ebpf:"async_reset_args"`
	Events          *ebpf.MapSpec `ebpf:"events"`
	NodejsParentMap *ebpf.MapSpec `ebpf:"nodejs_parent_map"`
	PidCache        *ebpf.MapSpec `ebpf:"pid_cache"`
	ValidPids       *ebpf.MapSpec `ebpf:"valid_pids"`
}

// bpfObjects contains all objects after they have been loaded into the kernel.
//
// It can be passed to loadBpfObjects or ebpf.CollectionSpec.LoadAndAssign.
type bpfObjects struct {
	bpfPrograms
	bpfMaps
}

func (o *bpfObjects) Close() error {
	return _BpfClose(
		&o.bpfPrograms,
		&o.bpfMaps,
	)
}

// bpfMaps contains all maps after they have been loaded into the kernel.
//
// It can be passed to loadBpfObjects or ebpf.CollectionSpec.LoadAndAssign.
type bpfMaps struct {
	ActiveNodejsIds *ebpf.Map `ebpf:"active_nodejs_ids"`
	AsyncResetArgs  *ebpf.Map `ebpf:"async_reset_args"`
	Events          *ebpf.Map `ebpf:"events"`
	NodejsParentMap *ebpf.Map `ebpf:"nodejs_parent_map"`
	PidCache        *ebpf.Map `ebpf:"pid_cache"`
	ValidPids       *ebpf.Map `ebpf:"valid_pids"`
}

func (m *bpfMaps) Close() error {
	return _BpfClose(
		m.ActiveNodejsIds,
		m.AsyncResetArgs,
		m.Events,
		m.NodejsParentMap,
		m.PidCache,
		m.ValidPids,
	)
}

// bpfPrograms contains all programs after they have been loaded into the kernel.
//
// It can be passed to loadBpfObjects or ebpf.CollectionSpec.LoadAndAssign.
type bpfPrograms struct {
	AsyncReset    *ebpf.Program `ebpf:"async_reset"`
	AsyncResetRet *ebpf.Program `ebpf:"async_reset_ret"`
	EmitAsyncInit *ebpf.Program `ebpf:"emit_async_init"`
}

func (p *bpfPrograms) Close() error {
	return _BpfClose(
		p.AsyncReset,
		p.AsyncResetRet,
		p.EmitAsyncInit,
	)
}

func _BpfClose(closers ...io.Closer) error {
	for _, closer := range closers {
		if err := closer.Close(); err != nil {
			return err
		}
	}
	return nil
}

// Do not access this directly.
//
//go:embed bpf_x86_bpfel.o
var _BpfBytes []byte
